--- typo3_src-4.0.2/t3lib/class.t3lib_tcemain.php	2006-09-11 09:18:01.000000000 +0200
+++ hooktest/typo3_src-4.0.2/t3lib/class.user_tcemain.php	2006-10-10 12:11:08.949986532 +0200
@@ -3842,7 +3842,22 @@
 	 * @return	boolean		Returns true if the user has general access to modify the $table
 	 */
 	function checkModifyAccessList($table)	{
+		global $TYPO3_CONF_VARS;
+		// First prepare user defined objects (if any) for hooks which extend this function:
+		// This hook allows to delegate the checking to a decentral method and so you get a chance to 
+		// tune the modification-rights within your extension
+		$hookObjectsArr = array();
+		if (is_array ($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['checkModifyAccessList'])) {
+			foreach ($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['checkModifyAccessList'] as $classRef) {
+				$hookObjectsArr[] = &t3lib_div::getUserObj($classRef);
+			}
+		}
 		$res = ($this->admin || (!$this->tableAdminOnly($table) && t3lib_div::inList($this->BE_USER->groupData['tables_modify'],$table)));
+		foreach($hookObjectsArr as $hookObj)	{
+			if (method_exists($hookObj, 'recheckModifyAccessList')) {
+				$hookObj->recheckModifyAccessList($table, $this->cmdmap, $this, &$res);
+			}
+		}
 		return $res;
 	}
 
